# -*- coding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from operator import itemgetter
import time

from openerp.osv import fields, osv


class res_partner(osv.Model):

    _inherit = 'res.partner'

    _columns = {
        'property_payment_term_p_suppliers': fields.property(
            'payment.terms.partner',
             type='many2one',
             relation='payment.terms.partner',
             string ='Payment Term Supplier',
            view_load=True,
             help="This payment term will be used instead of the default one "
                  "for purchase orders and supplier invoices"),
        'property_payment_term_p_customer': fields.property(
            'payment.terms.partner',
             type='many2one',
             relation='payment.terms.partner',
            view_load=True,
             string ='Payment Term Customer',
             help="This payment term will be used instead of the default one "
                  "for sale orders and customer invoices"),
    }

