#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    Module Writen to OpenERP, Open Source Management Solution
#    Copyright (C) Vauxoo (<http://vauxoo.com>).
#    All Rights Reserved
###############Credits######################################################
#    Coded by: Vauxoo C.A.           
#    Planified by: Nhomar Hernandez
#    Audited by: Vauxoo C.A.
#############################################################################
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
################################################################################
{
    "name" : "Price Structure",
    "version" : "0.1",
    "depends" : ['product','sale','cost_structure'],
    "author" : "Vauxoo",
    "description" : """
   This module adds a new functionality to manage price lists for products adding a new tab on the product 
   view where you can see the price lists where this product is affected either by product or by category.

   It also adds a new feature to the time of a sale, allowing you to choose a price list through which Live 
   will calculate to give a product price depending on the price list q be selected, regardless of whether 
   the list price selected at the beginning of the order.

   This also adds a blockade preventing sold when selling a product at a price higher or lower than estimated 
   by their price lists
    
    """,
    "website" : "http://vauxoo.com",
    "category" : "Generic Modules",
    "init_xml" : [],
    "demo_xml" : [],
    "test": [ ],
    "update_xml" : [
    'view/product_view.xml',
    'view/sale_view.xml',
    'view/product_pricelist_view.xml',
    'workflow/sale_workflow.xml',
    'wizard/create_list_price_view.xml',
    
    
    
    
    ],
    "active": False,
    "installable": True,
}
